package it.sw.pa.comune.artegna.web.rest;

import it.sw.pa.comune.artegna.repository.MessaggioRepository;
import it.sw.pa.comune.artegna.service.MessaggioService;
import it.sw.pa.comune.artegna.service.dto.MessaggioDTO;
import it.sw.pa.comune.artegna.web.rest.errors.BadRequestAlertException;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.List;
import java.util.Objects;
import java.util.Optional;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import tech.jhipster.web.util.HeaderUtil;
import tech.jhipster.web.util.ResponseUtil;

/**
 * REST controller for managing {@link it.sw.pa.comune.artegna.domain.Messaggio}.
 */
@RestController
@RequestMapping("/api/messaggios")
public class MessaggioResource {

    private static final Logger LOG = LoggerFactory.getLogger(MessaggioResource.class);

    private static final String ENTITY_NAME = "messaggio";

    @Value("${jhipster.clientApp.name:smartbooking}")
    private String applicationName;

    private final MessaggioService messaggioService;

    private final MessaggioRepository messaggioRepository;

    public MessaggioResource(MessaggioService messaggioService, MessaggioRepository messaggioRepository) {
        this.messaggioService = messaggioService;
        this.messaggioRepository = messaggioRepository;
    }

    /**
     * {@code POST  /messaggios} : Create a new messaggio.
     *
     * @param messaggioDTO the messaggioDTO to create.
     * @return the {@link ResponseEntity} with status {@code 201 (Created)} and with body the new messaggioDTO, or with status {@code 400 (Bad Request)} if the messaggio has already an ID.
     * @throws URISyntaxException if the Location URI syntax is incorrect.
     */
    @PostMapping("")
    public ResponseEntity<MessaggioDTO> createMessaggio(@RequestBody MessaggioDTO messaggioDTO) throws URISyntaxException {
        LOG.debug("REST request to save Messaggio : {}", messaggioDTO);
        if (messaggioDTO.getId() != null) {
            throw new BadRequestAlertException("A new messaggio cannot already have an ID", ENTITY_NAME, "idexists");
        }
        messaggioDTO = messaggioService.save(messaggioDTO);
        return ResponseEntity.created(new URI("/api/messaggios/" + messaggioDTO.getId()))
            .headers(HeaderUtil.createEntityCreationAlert(applicationName, true, ENTITY_NAME, messaggioDTO.getId().toString()))
            .body(messaggioDTO);
    }

    /**
     * {@code PUT  /messaggios/:id} : Updates an existing messaggio.
     *
     * @param id the id of the messaggioDTO to save.
     * @param messaggioDTO the messaggioDTO to update.
     * @return the {@link ResponseEntity} with status {@code 200 (OK)} and with body the updated messaggioDTO,
     * or with status {@code 400 (Bad Request)} if the messaggioDTO is not valid,
     * or with status {@code 500 (Internal Server Error)} if the messaggioDTO couldn't be updated.
     * @throws URISyntaxException if the Location URI syntax is incorrect.
     */
    @PutMapping("/{id}")
    public ResponseEntity<MessaggioDTO> updateMessaggio(
        @PathVariable(value = "id", required = false) final Long id,
        @RequestBody MessaggioDTO messaggioDTO
    ) throws URISyntaxException {
        LOG.debug("REST request to update Messaggio : {}, {}", id, messaggioDTO);
        if (messaggioDTO.getId() == null) {
            throw new BadRequestAlertException("Invalid id", ENTITY_NAME, "idnull");
        }
        if (!Objects.equals(id, messaggioDTO.getId())) {
            throw new BadRequestAlertException("Invalid ID", ENTITY_NAME, "idinvalid");
        }

        if (!messaggioRepository.existsById(id)) {
            throw new BadRequestAlertException("Entity not found", ENTITY_NAME, "idnotfound");
        }

        messaggioDTO = messaggioService.update(messaggioDTO);
        return ResponseEntity.ok()
            .headers(HeaderUtil.createEntityUpdateAlert(applicationName, true, ENTITY_NAME, messaggioDTO.getId().toString()))
            .body(messaggioDTO);
    }

    /**
     * {@code PATCH  /messaggios/:id} : Partial updates given fields of an existing messaggio, field will ignore if it is null
     *
     * @param id the id of the messaggioDTO to save.
     * @param messaggioDTO the messaggioDTO to update.
     * @return the {@link ResponseEntity} with status {@code 200 (OK)} and with body the updated messaggioDTO,
     * or with status {@code 400 (Bad Request)} if the messaggioDTO is not valid,
     * or with status {@code 404 (Not Found)} if the messaggioDTO is not found,
     * or with status {@code 500 (Internal Server Error)} if the messaggioDTO couldn't be updated.
     * @throws URISyntaxException if the Location URI syntax is incorrect.
     */
    @PatchMapping(value = "/{id}", consumes = { "application/json", "application/merge-patch+json" })
    public ResponseEntity<MessaggioDTO> partialUpdateMessaggio(
        @PathVariable(value = "id", required = false) final Long id,
        @RequestBody MessaggioDTO messaggioDTO
    ) throws URISyntaxException {
        LOG.debug("REST request to partial update Messaggio partially : {}, {}", id, messaggioDTO);
        if (messaggioDTO.getId() == null) {
            throw new BadRequestAlertException("Invalid id", ENTITY_NAME, "idnull");
        }
        if (!Objects.equals(id, messaggioDTO.getId())) {
            throw new BadRequestAlertException("Invalid ID", ENTITY_NAME, "idinvalid");
        }

        if (!messaggioRepository.existsById(id)) {
            throw new BadRequestAlertException("Entity not found", ENTITY_NAME, "idnotfound");
        }

        Optional<MessaggioDTO> result = messaggioService.partialUpdate(messaggioDTO);

        return ResponseUtil.wrapOrNotFound(
            result,
            HeaderUtil.createEntityUpdateAlert(applicationName, true, ENTITY_NAME, messaggioDTO.getId().toString())
        );
    }

    /**
     * {@code GET  /messaggios} : get all the messaggios.
     *
     * @param eagerload flag to eager load entities from relationships (This is applicable for many-to-many).
     * @return the {@link ResponseEntity} with status {@code 200 (OK)} and the list of messaggios in body.
     */
    @GetMapping("")
    public List<MessaggioDTO> getAllMessaggios(
        @RequestParam(name = "eagerload", required = false, defaultValue = "true") boolean eagerload
    ) {
        LOG.debug("REST request to get all Messaggios");
        return messaggioService.findAll();
    }

    /**
     * {@code GET  /messaggios/:id} : get the "id" messaggio.
     *
     * @param id the id of the messaggioDTO to retrieve.
     * @return the {@link ResponseEntity} with status {@code 200 (OK)} and with body the messaggioDTO, or with status {@code 404 (Not Found)}.
     */
    @GetMapping("/{id}")
    public ResponseEntity<MessaggioDTO> getMessaggio(@PathVariable("id") Long id) {
        LOG.debug("REST request to get Messaggio : {}", id);
        Optional<MessaggioDTO> messaggioDTO = messaggioService.findOne(id);
        return ResponseUtil.wrapOrNotFound(messaggioDTO);
    }

    /**
     * {@code DELETE  /messaggios/:id} : delete the "id" messaggio.
     *
     * @param id the id of the messaggioDTO to delete.
     * @return the {@link ResponseEntity} with status {@code 204 (NO_CONTENT)}.
     */
    @DeleteMapping("/{id}")
    public ResponseEntity<Void> deleteMessaggio(@PathVariable("id") Long id) {
        LOG.debug("REST request to delete Messaggio : {}", id);
        messaggioService.delete(id);
        return ResponseEntity.noContent()
            .headers(HeaderUtil.createEntityDeletionAlert(applicationName, true, ENTITY_NAME, id.toString()))
            .build();
    }
}
